package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.DateUtils;
import com.ims.eval.config.CustomException;
import com.ims.eval.dao.BinSectionMapper;
import com.ims.eval.dao.EvaluationScoreCountMapper;
import com.ims.eval.entity.BinSection;
import com.ims.eval.entity.EvaluationScoreCount;
import com.ims.eval.service.IBinSectionService;
import com.ims.eval.service.IEvaluationScoreCountService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 考评得分统计 服务实现类
 * </p>
 *
 * @author xugp
 * @since 2023-03-20
 */
@Service
public class EvaluatioinScoreCountServiceImpl extends ServiceImpl<EvaluationScoreCountMapper, EvaluationScoreCount> implements IEvaluationScoreCountService {


	@Override
	public List<EvaluationScoreCount> getListByEvaluationRuleId(String organizationEvaluationId, String organizationEvaluationRuleId, String binStage) {
		List<EvaluationScoreCount> list = baseMapper.selelctListByEvaluationRuleId(organizationEvaluationId, organizationEvaluationRuleId, binStage);
		return list;
	}


	@Override
	public Map<String, Object> evaluationList(String binSection, String binStage, String type, String condition, String date) {
		Map<String, Object> result = new HashMap<>();
		List<Map<String, Object>> list = new ArrayList<>();
		String month = null;
		Calendar cal = Calendar.getInstance();
		cal.setTime(DateUtils.strToDate(date, DateUtils.format3));
		String year = String.valueOf(cal.get(Calendar.YEAR));
		if (condition.equals("JDKP")){
			month = String.valueOf(DateUtils.getSeason(cal.getTime()));
		}
		if (condition.equals("YDKP")){
			month = String.valueOf(cal.get(Calendar.MONTH) + 1);
		}
		try {
			list.addAll(baseMapper.selectEvaluationList(binSection, binStage, type, condition, year, month));
		} catch (Exception e) {
			return result;
		}

		Map<Object, List<Map<String, Object>>> collect = list.stream().collect(Collectors.groupingBy(c -> c.get("organization_name"), Collectors.toList()));
		boolean flag = true;
		List<Object> value = new ArrayList<>();
		List<Object> title = new ArrayList<>();
		for (Map.Entry<Object, List<Map<String, Object>>> entry : collect.entrySet()) {
			List<Map<String, Object>> v = entry.getValue();
			Map<String, Object> mp = new HashMap<>();
			for (int i = 0; i < v.size(); i++) {
				Map<String, Object> item = v.get(i);
				mp.put(item.get("indicator_code").toString(), item.get("score"));
				mp.put("organization_name", item.get("organization_name"));
				mp.put(item.get("indicator_code").toString() + "_flag", item.get("score") == item.get("standard_score") ? "0"
					: Double.valueOf(item.get("score").toString()) > Double.valueOf(item.get("standard_score").toString()) ? "1" : "-1");

				if (flag) {
					Map<String, Object> tl = new HashMap<>();
					tl.put("key", item.get("indicator_name"));
					tl.put("code", item.get("indicator_code").toString() + "_score");
					title.add(tl);
				}
			}
			flag = false;
			value.add(mp);
		}

		result.put("title", title);
		result.put("value", value);
		return result;
	}
}
