package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationNoticeMapper;
import com.ims.eval.entity.DataDictionary;
import com.ims.eval.entity.EvaluationNotice;
import com.ims.eval.entity.custom.Path;
import com.ims.eval.service.IDataDictionaryService;
import com.ims.eval.service.IEvaluationNoticeService;
import com.ims.eval.util.FileUploadUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Date;

/**
 * @author hlf
 * @date 2023/5/17 14:39
 * 文件说明：
 */
@Service
public class EvaluationNoticeServiceImpl extends ServiceImpl<EvaluationNoticeMapper, EvaluationNotice> implements IEvaluationNoticeService {

	@Autowired
	private IDataDictionaryService dataDictionaryService;

	@Override
	public IPage<EvaluationNotice> listPage(Integer pageNum, Integer pageSize, String noticeTitle) {
		if (null == pageNum || null == pageSize) {
			throw new RuntimeException("分页参数为空");
		}
		//构造分页构造器
		Page<EvaluationNotice> page = new Page<>(pageNum, pageSize);
		return baseMapper.selectListPage(page, noticeTitle);
	}

	@Override
	public boolean saveOrUpdate(EvaluationNotice evaluationNotice, MultipartFile[] files) throws IOException {
		StringBuilder fileNames = new StringBuilder();
		if (files.length > 0) {
			for (MultipartFile file : files) {
				// 上传文件路径
				String filePath = Path.getNoticePath();
				// 上传并返回新文件名称
				String fileName = null;
				fileName = FileUploadUtil.upload(filePath, file);
				fileNames.append(fileName).append(",");
			}
		}
		if (fileNames.toString().length() > 0) {
			evaluationNotice.setNoticeAnnex(fileNames.toString().substring(0, fileNames.toString().length() - 1));
		}
		DataDictionary dataDictionary = dataDictionaryService.getById(evaluationNotice.getReleaseDeptId());
		if (null != dataDictionary) {
			evaluationNotice.setReleaseDeptName(dataDictionary.getKeyName());
			evaluationNotice.setReleaseDeptCode(dataDictionary.getDataKey());
		}
		if ("".equals(evaluationNotice.getId()) || null == evaluationNotice.getId()) {
			evaluationNotice.setCreateTime(new Date());
		} else {
			evaluationNotice.setUpdateTime(new Date());
		}
		return super.saveOrUpdate(evaluationNotice);
	}
}
